package at.xaxa.ledger.ui.category.edit

import android.util.Log
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.foundation.layout.fillMaxWidth
import androidx.compose.foundation.layout.padding
import androidx.compose.material3.DropdownMenuItem
import androidx.compose.material3.ExperimentalMaterial3Api
import androidx.compose.material3.ExposedDropdownMenuBox
import androidx.compose.material3.ExposedDropdownMenuDefaults.TrailingIcon
import androidx.compose.material3.OutlinedTextField
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.compose.runtime.collectAsState
import androidx.compose.runtime.getValue
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.remember
import androidx.compose.runtime.setValue
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.unit.dp
import androidx.lifecycle.viewmodel.compose.viewModel
import at.xaxa.ledger.data.Entry
import at.xaxa.ledger.ui.AppViewModelProvider
import at.xaxa.ledger.ui.ButtonDanger
import at.xaxa.ledger.ui.ButtonSuccess
import at.xaxa.ledger.ui.DatePickerDocked
import at.xaxa.ledger.ui.entry.edit.EditViewModel


@OptIn(ExperimentalMaterial3Api::class)
@Composable
fun EditCategory(modifier: Modifier = Modifier, onCardClick: () -> Unit, editViewModel : EditViewModel = viewModel(factory = AppViewModelProvider.Factory), onValueChange: (Entry) -> Unit = {},
) {
    /*
    val entry = editViewModel.editUiState.entry
    val category = editViewModel.categoryUi.category
    val categories by editViewModel.categoryListUiState.categories.collectAsState(initial = emptyList())

    var expanded by remember { mutableStateOf(false) }

    Column(
        modifier = modifier.fillMaxSize()
            .padding(16.dp, 0.dp),
        horizontalAlignment = Alignment.CenterHorizontally
    ) {
        Column(
            Modifier.weight(1f)
        ) {
            OutlinedTextField(
                value = entry.name,
                onValueChange = {editViewModel.updateEntry(entry.copy(name = it))},
                label = { Text("Name") },
                modifier = Modifier
                    .fillMaxWidth()
            )
            OutlinedTextField(
                value = entry.amount.toString(),
                onValueChange = { editViewModel.updateEntry(entry.copy(amount = it.toFloat())) },
                label = { Text("Spending") },
                modifier = Modifier
                    .fillMaxWidth()
            )

            ExposedDropdownMenuBox(
                expanded = expanded,
                onExpandedChange = { expanded = it }
            ) {
                // TextField to display the selected item and trigger the dropdown
                OutlinedTextField(
                    value = category.categoryName,
                    onValueChange = {},
                    label = { Text("Category") },
                    readOnly = true,
                    trailingIcon = {
                        TrailingIcon(expanded = expanded)
                    },
                    modifier = Modifier
                        .menuAnchor()
                        .fillMaxWidth()
                )

                // Dropdown menu
                ExposedDropdownMenu(
                    expanded = expanded,
                    onDismissRequest = { expanded = false }
                ) {
                    categories.forEach { item ->
                        DropdownMenuItem(
                            text = { Text(text = item.categoryName) },
                            onClick = {
                                entry.copy(categoryID = item._id)
                                editViewModel.updateEntry(entry)
                                expanded = false
                            }
                        )
                    }
                }
            }


            Log.w("xaver", entry.date.toString())

            DatePickerDocked(entry){
                    dateMilis -> editViewModel.updateEntry(entry.copy(date = dateMilis))
            }
        }

        Column(
            modifier = Modifier.fillMaxWidth(),
            horizontalAlignment = Alignment.CenterHorizontally // Center buttons horizontally
        ) {
            ButtonDanger(
                modifier = Modifier
                    .fillMaxWidth()
                    .padding(bottom = 8.dp),
                text = "Delete",
                onClick = { onCardClick() }
            )
            ButtonSuccess(
                modifier = Modifier.fillMaxWidth(), // Add spacing between buttons
                text = "Done",
                onClick = {
                    editViewModel.saveEntry()
                    onCardClick()
                }
            )
        }
    }*/
}
